"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExpressFileServerContribution = void 0;
const tslib_1 = require("tslib");
const di_1 = require("@opensumi/di");
const ide_core_browser_1 = require("@opensumi/ide-core-browser");
const static_definition_1 = require("@opensumi/ide-core-browser/lib/static-resource/static.definition");
const common_1 = require("../common");
let ExpressFileServerContribution = class ExpressFileServerContribution {
    registerStaticResolver(service) {
        service.registerStaticResourceProvider({
            scheme: ide_core_browser_1.Schemes.file,
            resolveStaticResource: (uri) => {
                // file 协议统一走静态服务
                // http://${HOST}:8000/assets/${path}
                const assetsUri = new ide_core_browser_1.URI(this.appConfig.staticServicePath || common_1.EXPRESS_SERVER_PATH);
                /**
                 * uri.path 在 Windows 下会被解析为 /c:/Path/to/file
                 * fsPath C:\\Path\\to\\file
                 */
                const [resourceUrl, query] = uri.codeUri.path.split('?');
                return assetsUri.resolve(`assets${decodeURIComponent(resourceUrl)}`).withQuery(query);
            },
            roots: [this.appConfig.staticServicePath || common_1.EXPRESS_SERVER_PATH],
        });
    }
};
tslib_1.__decorate([
    (0, di_1.Autowired)(ide_core_browser_1.AppConfig),
    tslib_1.__metadata("design:type", Object)
], ExpressFileServerContribution.prototype, "appConfig", void 0);
ExpressFileServerContribution = tslib_1.__decorate([
    (0, ide_core_browser_1.Domain)(static_definition_1.StaticResourceContribution)
], ExpressFileServerContribution);
exports.ExpressFileServerContribution = ExpressFileServerContribution;
//# sourceMappingURL=file-server.contribution.js.map